.386
.model flat,stdcall
option casemap:none

WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD

Include windows.inc
Include user32.inc
Include kernel32.inc
include comctl32.inc
include gdi32.inc

IncludeLib user32.lib
IncludeLib kernel32.lib
includelib comctl32.lib
includelib gdi32.lib

.DATA
ClassName		DB "MainWinClass",0
szAppName		DB "My Browser",0

szDLL			db	'atl.dll',0
szAtlAxWinInit  db	'AtlAxWinInit',0
szClass			db	'AtlAxWin',0
szUrl			db	'http://www.masmforum.com',0

.DATA?
hInstance		HINSTANCE ?
CommandLine		LPSTR ?
hWeb			dd ?
hLib			dd ?

.CONST

.CODE

Start:
	
	Invoke LoadLibrary,Offset szDLL
	mov hLib,eax
	Invoke GetProcAddress,hLib,ADDR szAtlAxWinInit
	call eax
	invoke GetModuleHandle, NULL
	mov	hInstance, eax
	Invoke GetCommandLine
	MOV CommandLine, EAX
	invoke InitCommonControls
	Invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	Invoke FreeLibrary,hLib
	invoke ExitProcess, eax
	
WinMain Proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
Local wc:WNDCLASSEX
Local msg:MSG
Local hwnd:HWND

	MOV wc.cbSize, SizeOf WNDCLASSEX
	MOV wc.style, CS_HREDRAW or CS_VREDRAW
	MOV wc.lpfnWndProc, Offset WndProc
	MOV wc.cbClsExtra,NULL
	MOV wc.cbWndExtra,NULL
	PUSH hInst
	POP wc.hInstance
	MOV wc.hbrBackground, COLOR_BTNFACE+1
	MOV wc.lpszMenuName, NULL
	MOV wc.lpszClassName, Offset ClassName
	Invoke LoadIcon, NULL, IDI_APPLICATION
	MOV wc.hIcon,EAX
	MOV wc.hIconSm,0
	Invoke LoadCursor, NULL, IDC_ARROW
	MOV wc.hCursor,EAX
	Invoke RegisterClassEx, addr wc
	Invoke CreateWindowEx, WS_EX_APPWINDOW, ADDR ClassName, ADDR szAppName,\
           WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT, NULL, NULL,\
           hInst, NULL
	MOV hwnd,EAX
	Invoke ShowWindow, hwnd, CmdShow
	Invoke UpdateWindow, hwnd
	.While TRUE
		Invoke GetMessage, ADDR msg, NULL, 0, 0
		.Break .If (!EAX)
		Invoke TranslateMessage, ADDR msg
		Invoke DispatchMessage, ADDR msg
	.EndW
	MOV EAX, msg.wParam
	RET
WinMain endp

WndProc Proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	local rect:RECT
	
	.If uMsg==WM_DESTROY
		invoke DeleteObject,hWeb
		Invoke PostQuitMessage, NULL
	.ElseIf uMsg==WM_ACTIVATE
		; create web control...
		
		invoke CreateWindowEx,NULL,addr szClass,addr szUrl,WS_CHILD or WS_VISIBLE or WS_BORDER or WS_HSCROLL or WS_VSCROLL,0,0,0,0,hWnd,NULL,hInstance,NULL
		mov hWeb, eax
	
	.elseif uMsg == WM_SIZE
		
		invoke GetWindowRect,hWnd,addr rect
		
		sub rect.bottom,130
		sub rect.right,130
		
		invoke MoveWindow,hWeb,5,5,rect.right,rect.bottom,TRUE
		
	.Else
		Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		RET
	.EndIf
	XOR EAX,EAX
	RET
WndProc EndP

End Start
